import static java.lang.Math.*;
public class functorWorld extends Thread{
    world olWorld;
    int start,
        end;
    atom atomSrc[],
         atomDest[];
    //worldFunc f = new worldFunc();
    
    atomFunc a = new atomFunc();
    vectorFunc v = new vectorFunc();
    
    public functorWorld(world _olWorld, atom [] atomLst, int _start, int _end)
    {
        olWorld = _olWorld;
        start = _start;
        end = _end;
        atomSrc = atomLst;
        atomDest = new atom[end-start];
        
    }
    
    public void run()
    {
        atom nuAtom;
        for (int i=start;i<end;i++)
        {
        
            nuAtom = new atom(atomSrc[i]);
            //hardcollision with the world
            vector delta = v.sub(olWorld.center, nuAtom.pos);
            double refDistSQ = pow(olWorld.radius- nuAtom.radius,2);
            double diffDistSQ = v.magSQ(delta) - refDistSQ;
            if (diffDistSQ > 0)
            {
                nuAtom = a.addforce(nuAtom, a.invRepulseSQ(nuAtom, olWorld.center, (olWorld.radius- nuAtom.radius), v.magSQ(delta),0.9, 0.1));
            }
            nuAtom = a.terminalforces(nuAtom);
            
            //gravity
            //nuAtom = a.addforce(nuAtom, v.scale(olWorld.gravity, nuAtom.mass));
            nuAtom = a.addVel(nuAtom, olWorld.gravity);

            //nuAtom = a.terminalvelocity(nuAtom);
            //velocitydrag
            nuAtom = a.subVel(nuAtom, v.scale(nuAtom.vel, 0.01));
            //  wind
            //  etc

            //
            //nuWorld.append(nuAtom);
            atomDest[i-start] = nuAtom;
        }
    }
}
