import java.awt.*;
import java.applet.*;
public class worldTest
{
    /*________________________________
    ___________Variable_____________*/
    //functor
    pigFunc pig = new pigFunc();
    //worldFunc w = new worldFunc();
    atomFunc a = new atomFunc();
    vectorFunc v = new vectorFunc();
    //constant
    int maxAtoms = 500;                             // max atom allowed
    //double deltaT = 0.001d;                         // physics frame lenght
    double deltaT = 1;                         // physics frame lenght
    
    world U = new world(new vector(570,295), 240);
    atom atomPool[] = new atom[maxAtoms];
    int atomQty = 0;
    /*________________________________
    ___________Initialisation_______*/
    public void initialize() 
    {

        atomPool[atomQty++] = (new atom(650, 250, 0, 0, 5, 12));         // spawn the square spring
        atomPool[atomQty++]=(new atom(680, 290, 1, 0, 5, 12));
        atomPool[atomQty++]=(new atom(680, 250, 2, 0, 5, 12));
        atomPool[atomQty++]=(new atom(650, 290, 3, 0, 5, 12));
        
        atomPool[atomQty++]=(new atom(580, 250, 4, 0, 5, 12));         // spawn the square spring
        atomPool[atomQty++]=(new atom(610, 290, 5, 0, 5, 12));
        atomPool[atomQty++]=(new atom(610, 250, 6, 0, 5, 12));
        atomPool[atomQty++]=(new atom(580, 290, 7, 0, 5, 12));
        atomPool[atomQty++]=(new atom(530, 270, 8, 0, 5, 12));         // spawn the square spring
        atomPool[atomQty++]=(new atom(530, 290, 9, 0, 5, 12));
        atomPool[atomQty++]=(new atom(550, 290, 10, 0, 5, 12));
        atomPool[atomQty++]=(new atom(550, 270, 11, 0, 5, 12));
        
        for (int i=0;i<5;i++)                       // atom fountain machine 
        {
            atomPool[atomQty++]=(new atom(760, 82, i+12, 0, 6, 16));
        }
        for (int i=5;i<8;i++)
        {
            atomPool[atomQty++]=(new atom(600, 80, i+12, 0, 8, 12));
        }
        for (int i=8;i<15;i++)
        {
            atomPool[atomQty++]=(new atom(530, 20, i+12, 0, 52, 8));
        }
        for (int i=15;i<maxAtoms-12;i++)
        {
            atomPool[atomQty++]=(new atom(640, 440, i+12, 4, 20, 3));
        }
                                                                // make some springs; hardcoded
        //new spring struct
        
        atomPool[0] = a.linkWith(atomPool[0],1,v.dist(atomPool[0].pos, atomPool[1].pos));
        atomPool[1] = a.linkWith(atomPool[1],0,v.dist(atomPool[0].pos, atomPool[1].pos));
        atomPool[2] = a.linkWith(atomPool[2],3,v.dist(atomPool[2].pos, atomPool[3].pos));
        atomPool[3] = a.linkWith(atomPool[3],2,v.dist(atomPool[2].pos, atomPool[3].pos));
        atomPool[1] = a.linkWith(atomPool[1],2,v.dist(atomPool[1].pos, atomPool[2].pos));
        atomPool[3] = a.linkWith(atomPool[3],1,v.dist(atomPool[3].pos, atomPool[1].pos));
        atomPool[2] = a.linkWith(atomPool[2],0,v.dist(atomPool[2].pos, atomPool[0].pos));
        atomPool[3] = a.linkWith(atomPool[3],0,v.dist(atomPool[3].pos, atomPool[0].pos));
        atomPool[2] = a.linkWith(atomPool[2],1,v.dist(atomPool[1].pos, atomPool[2].pos));
        atomPool[1] = a.linkWith(atomPool[1],3,v.dist(atomPool[3].pos, atomPool[1].pos));
        atomPool[0] = a.linkWith(atomPool[0],2,v.dist(atomPool[2].pos, atomPool[0].pos));
        atomPool[0] = a.linkWith(atomPool[0],3,v.dist(atomPool[3].pos, atomPool[0].pos));
        
        atomPool[4] = a.linkWith(atomPool[4],5,v.dist(atomPool[4].pos, atomPool[5].pos));
        atomPool[6] = a.linkWith(atomPool[6],7,v.dist(atomPool[6].pos, atomPool[7].pos));
        atomPool[5] = a.linkWith(atomPool[5],6,v.dist(atomPool[5].pos, atomPool[6].pos));
        atomPool[7] = a.linkWith(atomPool[7],5,v.dist(atomPool[7].pos, atomPool[5].pos));
        atomPool[6] = a.linkWith(atomPool[6],4,v.dist(atomPool[6].pos, atomPool[4].pos));
        atomPool[7] = a.linkWith(atomPool[7],4,v.dist(atomPool[7].pos, atomPool[4].pos));

        atomPool[5] = a.linkWith(atomPool[5],4,v.dist(atomPool[4].pos, atomPool[5].pos));
        atomPool[7] = a.linkWith(atomPool[7],6,v.dist(atomPool[6].pos, atomPool[7].pos));
        atomPool[6] = a.linkWith(atomPool[6],5,v.dist(atomPool[5].pos, atomPool[6].pos));
        atomPool[5] = a.linkWith(atomPool[5],7,v.dist(atomPool[7].pos, atomPool[5].pos));
        atomPool[4] = a.linkWith(atomPool[4],6,v.dist(atomPool[6].pos, atomPool[4].pos));
        atomPool[4] = a.linkWith(atomPool[4],7,v.dist(atomPool[7].pos, atomPool[4].pos));
       
        atomPool[8] = a.linkWith(atomPool[8],7,v.dist(atomPool[8].pos, atomPool[7].pos));
        atomPool[9] = a.linkWith(atomPool[9],7,v.dist(atomPool[9].pos, atomPool[7].pos));
        atomPool[9] = a.linkWith(atomPool[9],6,v.dist(atomPool[9].pos, atomPool[6].pos));
        atomPool[8] = a.linkWith(atomPool[8],9,v.dist(atomPool[8].pos, atomPool[9].pos));

        atomPool[7] = a.linkWith(atomPool[7],8,v.dist(atomPool[8].pos, atomPool[7].pos));
        atomPool[7] = a.linkWith(atomPool[7],9,v.dist(atomPool[9].pos, atomPool[7].pos));
        atomPool[6] = a.linkWith(atomPool[6],9,v.dist(atomPool[9].pos, atomPool[6].pos));
        atomPool[9] = a.linkWith(atomPool[9],8,v.dist(atomPool[8].pos, atomPool[9].pos));
   

    }
    /*________________________________
    ___________Main Loop____________*/
    public void loop()
    {

        functorAtomForce processAtomForce = new functorAtomForce(U, atomPool, 0, atomQty, atomQty);
        processAtomForce.start();
        try {
           processAtomForce.join();
        } catch (InterruptedException ignore) {}
        atomPool = processAtomForce.atomDest;
        
        
        functorWorld processWorld = new functorWorld(U, atomPool, 0, atomQty);
        processWorld.start();
        try {
           processWorld.join();
        } catch (InterruptedException ignore) {}
        atomPool = processWorld.atomDest;
        
        functorIntegrate processForce = new functorIntegrate(U, atomPool, 0, atomQty, deltaT);
        processForce.start();
        try {
           processForce.join();
        } catch (InterruptedException ignore) {}
        atomPool = processForce.atomDest;

    }
    
    /*________________________________
    ___________draw_________________*/
    public void paint (Graphics g) 
    {
        //draw something
        g.setColor(Color.black);
        g.drawLine(400,60,500,60);
        g.drawString("World Test",502,64);

        g.setColor(Color.blue);
        for (int i=0; i<maxAtoms; i++)
        {
            pig.circle(g, atomPool[i].pos, atomPool[i].radius);
        }
        
        g.setColor(Color.green);
        for (int i =0;i<atomQty;i++)
            for (int j=0; j<atomPool[i].linkQty;j++)
            {
                pig.line(g, atomPool[i].pos, atomPool[atomPool[i].linkedTo[j]].pos);
            }
        
        g.setColor(Color.red);
        pig.circle(g, U.center, (int)U.radius);
    }
}
